# 功能：计时秒表
# 实验：暂停状态下按下A键，计时开始
#       开始状态下按下A键，计时暂停
#       按下B键，计时清零

import time
import machine
from machine import Pin,Timer
from mpython import *

second = 0
milliseconds = 0
tim = Timer(-1)
start = 0

def init_system():
  milliseconds = 0
  second = 0    
  oled.fill(0)
  oled.DispChar("秒表", 32, 0)
  oled.DispChar("开始", 32, 16)
  oled.DispChar("%04d : %03d"%(second,milliseconds), 16, 32)
  oled.show()

def timer_cb(t):
  global milliseconds,second,start
  if(start == 0):
    oled.show()
    return
  milliseconds = milliseconds + 100
  if milliseconds >= 1000:
    second = second +1
    milliseconds = 0
  oled.DispChar("%04d : %03d"%(second,milliseconds), 16, 32)
  oled.show()

tim.init(period=100, mode=Timer.PERIODIC, callback=timer_cb)

try:
  init_system()
  while True:
    value_a = button_a.value()
    value_b = button_b.value()
    if(value_a == 0):
      start = 1-start
      if start == 1:
        oled.DispChar("暂停", 32, 16)
      else:
        oled.DispChar("开始", 32, 16)
      while True:
        if(button_a.value() == 1):
          break

    if(value_b == 0):
      init_system()
      
    time.sleep(0.05)
except:
  tim.deinit()