# 功能：使用加速度计控制舵机
# 实验：将180度舵机接在pin0口，运行此文件
#           翻转掌控板，舵机可以跟随掌控板的姿态变化
#注意事项：这个实验使用加速度的x分量，注意翻转方向

from mpython import *
import time
import json

myServo=Servo(0,min_us=500, max_us=2500)

while True:
  x = accelerometer.get_x()
  if abs(x) > 1:
    x = x/abs(x)
  angle=int(numberMap(x,1,-1,0,180))
  myServo.write_angle(angle)   
  oled.DispChar("angle:%d" %angle,40,25)
  oled.show()
  oled.fill(0)
  time.sleep(0.01)